﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using EasyModbus;
using System.Linq;


namespace ProdigyModbus
{




    public partial class Form1 : Form
    {
        List<Panel> listPanel = new List<Panel>();
        int index;
        private ModbusClient modbusClient; // Store modbus client instance
        public Form1()
        {
            InitializeComponent();
        }


        //TCP Methods////////////////////////////////////////////////////////////////////////////

        private void write_multiple_holdingreg()
        {
            try
            {
                int j;
                ushort startAddress = Convert.ToUInt16(writeholdregstart.Value);
                int s = Convert.ToInt16(writeholdregnumberreg.Value);
                int[] registers = new int[s];

                string authors = writeholdreginp.Text;
                string[] authorsList = authors.Split(' ');
                for (j = 0; j < (s); j++)
                {
                    int auth = Convert.ToUInt16(authorsList[j]);
                    registers[j] = Convert.ToUInt16(auth);
                }

                for (int i = 0; i < s ; i++)
                {
                    modbusClient.WriteMultipleRegisters(startAddress, registers);
                }
                return;
            }
            catch (Exception e)
            {
                MessageBox.Show("Error: Error Occured");
            }
        }

        private void read_holdingreg()
        {
            try
            {
                int startAddress = Convert.ToInt16(readholdregstart.Value);
                int numberRegisters = Convert.ToInt16(readholdregnumber.Value);
                int[] registers = modbusClient.ReadHoldingRegisters(startAddress, numberRegisters);
                ushort[] unsignedRegisters = registers.Select(x => (ushort)x).ToArray();
                readcoils.Text = String.Join(" , ", unsignedRegisters);
            }
            catch (Exception e)
            {
                MessageBox.Show("Error: Error Occured");
            }
        }

        private void write_coil()
        {
            try
            {
                ushort coil = Convert.ToUInt16(writesinglecoilstart.Value);
                string inpt = writesinglecoilinp.Text;
                string[] inptlist = inpt.Split(' ');
                char si = Convert.ToChar(inptlist[0]);
                if (si == '1')
                {
                    bool a = true;
                    modbusClient.WriteSingleCoil(coil, a);
                }
                else if (si == '0')
                {
                    bool a = false;
                    modbusClient.WriteSingleCoil(coil, a);
                }
            }
            catch (Exception e)
            {
                MessageBox.Show("Error: Error Occured");
            }
        }

        private void write_multiple_coils()
        {
            try
            {
                int i;
                ushort coil = Convert.ToUInt16(writemulticoilsstart.Value);
                ushort numbercoils = Convert.ToUInt16(writemulticoilsnumberofcoils.Value);
                string inpt = writemulticoilstextbox.Text;
                string[] inptlist = inpt.Split(' ');
                for (i = 0; i < (numbercoils); i++)
                {
                    char si = Convert.ToChar(inptlist[i]);
                    if (si == '1')
                    {
                        bool a = true;
                        modbusClient.WriteSingleCoil(coil, a);
                    }
                    if (si == '0')
                    {
                        bool a = false;
                        modbusClient.WriteSingleCoil(coil, a);
                    }
                    coil = ++coil;
                }
            }
            catch (Exception e)
            {
                MessageBox.Show("Error: Error Occured");
            }
        }

        private void read_coils()
        {
            try
            {
                int i;
                ushort startAddr = Convert.ToUInt16(readcoilsstart.Value);
                ushort numbercoils = Convert.ToUInt16(readnumbercoils.Value);
                string[] a = new string[numbercoils];
                bool[] coils = modbusClient.ReadCoils(startAddr, numbercoils);
                for (i = 0; i < numbercoils; i++)
                {
                    a[i] = coils[i] ? "1" : "0";                                   // Convert true (or) false to "1" (or) "0" and store in the array
                }
                // Join the array and display in the textbox
                readcoilstextbox.Text = String.Join(" , ", a);
                return;
            }
            catch (Exception e)
            {
                MessageBox.Show("Error: Error Occured");
            }
        }

        private void inputregs()
        {
            try
            {
                int startAddr = Convert.ToUInt16(inputregisterStart.Value);
                int numbercoils = Convert.ToUInt16(readinputregnumberofcoils.Value);
                int[] input = modbusClient.ReadInputRegisters(startAddr, numbercoils);
                inputregistertextbox.Text = String.Join(" , ", input);
            }
            catch (Exception e)
            {
                MessageBox.Show("Error: Error Occured");
            }

        }

        private void discreteinputregs()
        {
            try
            {
                int i;
                ushort startAddr = Convert.ToUInt16(discreteinpStart.Value);
                ushort numbercoils = Convert.ToUInt16(discreteinptnumberregs.Value);
                bool[] coils = modbusClient.ReadDiscreteInputs(startAddr, numbercoils);
                string[] values = coils.Select(c => c ? "1" : "0").ToArray();
                discreteinptextbox.Text = String.Join(" , ", values);
            }
            catch (Exception e)
            {
                MessageBox.Show("Error: Error Occured");
            }
        }

        private void coilsbutton_Click(object sender, EventArgs e)
        {

            listPanel.Add(panel2);
            listPanel.Add(panel3);
            listPanel.Add(panel5);
            listPanel.Add(panel4);
            listPanel.Add(panel6);
            listPanel.Add(panel7);
            listPanel.Add(panel9);


            if (Select.Text == "Disconnect")
            {

                listPanel[index].BringToFront();
                if (A1.Checked)
                {
                    index = 0;
                    panel2.BringToFront();
                }

                if (A2.Checked)
                {
                    index = 1;
                    panel3.BringToFront();
                }

                if (A3.Checked)
                {
                    index = 2;
                    panel5.BringToFront();

                }
                if (A4.Checked)
                {
                    index = 3;
                    panel4.BringToFront();

                }
                if (A5.Checked)
                {
                    index = 4;
                    panel6.BringToFront();
                }
                if (A6.Checked)
                {
                    index = 5;
                    panel7.BringToFront();
                }
                if (A7.Checked)
                {
                    index = 6;
                    panel9.BringToFront();
                }
            }
            else
            {
                MessageBox.Show("Connect to the module!");
            }
        }

        private void holdwr_Click(object sender, EventArgs e)
        {
            write_multiple_holdingreg();
        }

        private void readholdregbutto_Click(object sender, EventArgs e)
        {

            read_holdingreg();

        }

        private void writecoil_Click(object sender, EventArgs e)
        {
            write_coil();
        }

        private void readcoilbutton_Click(object sender, EventArgs e)
        {
            read_coils();
        }

        private void writemulticoilsbutton_Click(object sender, EventArgs e)
        {
            write_multiple_coils();
        }

        private void readinputregbutton_Click(object sender, EventArgs e)
        {
            inputregs();
        }

        private void discreteinpbutton_Click(object sender, EventArgs e)
        {
            discreteinputregs();
        }

        private void Select_Click(object sender, EventArgs e)
        {

            if (Select.Text == "Connect")
            {
                try
                {

                    string ip = connectiontextbox.Text;

                    modbusClient = new ModbusClient(ip, 502);    //Ip-Address and Port of Modbus-TCP-Server

                    modbusClient.Connect();

                    Select.Text = "Disconnect";

                    MessageBox.Show("Connected successfully!");

                }

                catch (Exception ex)
                {

                    string msgage = "Error: Connection Error";
                    MessageBox.Show(msgage);
                }
            }
            else
            {
                try
                {
                    modbusClient.Disconnect();
                    modbusClient = null;
                    Select.Text = "Connect";
                    MessageBox.Show("Disconnected successfully!");
                }
                catch (Exception ex)
                {

                    string msgage = "Error: Connection Error";
                    MessageBox.Show(msgage);
                }
            }
        }
    }
}
